# CfnInfluxDBInstance

A DB instance is an isolated database environment running in the cloud.

It is the basic building block of Amazon Timestream for InfluxDB. A DB instance can contain multiple user-created databases (or organizations and buckets for the case of InfluxDb 2.x databases), and can be accessed using the same client tools and applications you might use to access a standalone self-managed InfluxDB instance.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnInfluxDBInstance
Implements: IInspectable, ITaggableV2, IEnvironmentAware, IInfluxDBInstanceRef, IConstruct, IDependable

- CloudFormation: [`AWS::Timestream::InfluxDBInstance`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-timestream-influxdbinstance.html)
- Source: Generated code
- Type last changed: v2.258.0 · 4 Jun 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_timestream as timestream } from 'aws-cdk-lib';
const cfnInfluxDBInstance = new timestream.CfnInfluxDBInstance(this, 'MyCfnInfluxDBInstance', /* all optional props */ {
  allocatedStorage: 123,
  bucket: 'bucket',
  dbInstanceType: 'dbInstanceType',
  dbParameterGroupIdentifier: 'dbParameterGroupIdentifier',
  dbStorageType: 'dbStorageType',
  deploymentType: 'deploymentType',
  logDeliveryConfiguration: {
    s3Configuration: {
      bucketName: 'bucketName',
      enabled: false,
    },
  },
  maintenanceSchedule: {
    preferredMaintenanceWindow: 'preferredMaintenanceWindow',
    timezone: 'timezone',
  },
  name: 'name',
  networkType: 'networkType',
  organization: 'organization',
  password: 'password',
  port: 123,
  publiclyAccessible: false,
  tags: [{
    key: 'key',
    value: 'value',
  }],
  username: 'username',
  vpcSecurityGroupIds: ['vpcSecurityGroupIds'],
  vpcSubnetIds: ['vpcSubnetIds'],
});
```

## Initializer

```ts
new CfnInfluxDBInstance(scope: Construct, id: string, props?: CfnInfluxDBInstanceProps)
```

## Construct Props

- `allocatedStorage`: number — The amount of storage to allocate for your DB storage type in GiB (gibibytes).

- `bucket`: string — The name of the initial InfluxDB bucket.

  All InfluxDB data is stored in a bucket. A bucket combines the concept of a database and a retention period (the duration of time that each data point persists). A bucket belongs to an organization.

- `dbInstanceType`: string — The Timestream for InfluxDB DB instance type to run on.

- `dbParameterGroupIdentifier`: string — The name or id of the DB parameter group to assign to your DB instance.

  DB parameter groups specify how the database is configured. For example, DB parameter groups can specify the limit for query concurrency.

- `dbStorageType`: string — The Timestream for InfluxDB DB storage type to read and write InfluxDB data.

  You can choose between 3 different types of provisioned Influx IOPS included storage according to your workloads requirements:

  - Influx IO Included 3000 IOPS
  - Influx IO Included 12000 IOPS
  - Influx IO Included 16000 IOPS

- `deploymentType`: string — Specifies whether the Timestream for InfluxDB is deployed as Single-AZ or with a MultiAZ Standby for High availability.

- `logDeliveryConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnInfluxDBInstance.LogDeliveryConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_timestream.CfnInfluxDBInstance.LogDeliveryConfigurationProperty.html) — Configuration for sending InfluxDB engine logs to a specified S3 bucket.

- `maintenanceSchedule`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnInfluxDBInstance.MaintenanceScheduleProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_timestream.CfnInfluxDBInstance.MaintenanceScheduleProperty.html) — The maintenance schedule for the InfluxDB instance.

- `name`: string — The name that uniquely identifies the DB instance when interacting with the Amazon Timestream for InfluxDB API and CLI commands.

  This name will also be a prefix included in the endpoint. DB instance names must be unique per customer and per region.

- `networkType`: string — Network type of the InfluxDB Instance.

- `organization`: string — The name of the initial organization for the initial admin user in InfluxDB.

  An InfluxDB organization is a workspace for a group of users.

- `password`: string — The password of the initial admin user created in InfluxDB.

  This password will allow you to access the InfluxDB UI to perform various administrative tasks and also use the InfluxDB CLI to create an operator token. These attributes will be stored in a Secret created in Amazon SecretManager in your account.

- `port`: number — The port number on which InfluxDB accepts connections.

- `publiclyAccessible`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) = false — Configures the DB instance with a public IP to facilitate access.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A list of key-value pairs to associate with the DB instance.

- `username`: string — The username of the initial admin user created in InfluxDB.

  Must start with a letter and can't end with a hyphen or contain two consecutive hyphens. For example, my-user1. This username will allow you to access the InfluxDB UI to perform various administrative tasks and also use the InfluxDB CLI to create an operator token. These attributes will be stored in a Secret created in Amazon Secrets Manager in your account.

- `vpcSecurityGroupIds`: string[] — A list of VPC security group IDs to associate with the DB instance.

- `vpcSubnetIds`: string[] — A list of VPC subnet IDs to associate with the DB instance.

  Provide at least two VPC subnet IDs in different availability zones when deploying with a Multi-AZ standby.

## Properties

- `allocatedStorage`: number — The amount of storage to allocate for your DB storage type in GiB (gibibytes).

- `attrArn`: string — The Amazon Resource Name (ARN) of the DB instance.

- `attrAvailabilityZone`: string — The Availability Zone in which the DB instance resides.

- `attrEndpoint`: string — The endpoint used to connect to InfluxDB.

  The default InfluxDB port is 8086.

- `attrId`: string — A service-generated unique identifier.

- `attrInfluxAuthParametersSecretArn`: string — The Amazon Resource Name (ARN) of the Amazon Secrets Manager secret containing the initial InfluxDB authorization parameters.

  The secret value is a JSON formatted key-value pair holding InfluxDB authorization values: organization, bucket, username, and password.

- `attrNextMaintenanceTime`: string — The timestamp of the next scheduled maintenance event.

- `attrSecondaryAvailabilityZone`: string — Describes an Availability Zone in which the InfluxDB instance is located.

- `attrStatus`: string — The status of the DB instance.

  Valid Values: `CREATING` | `AVAILABLE` | `DELETING` | `MODIFYING` | `UPDATING` | `DELETED` | `FAILED`

- `bucket`: string — The name of the initial InfluxDB bucket.

- `cdkTagManager`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `creationStack`: string[]

- `dbInstanceType`: string — The Timestream for InfluxDB DB instance type to run on.

- `dbParameterGroupIdentifier`: string — The name or id of the DB parameter group to assign to your DB instance.

- `dbStorageType`: string — The Timestream for InfluxDB DB storage type to read and write InfluxDB data.

- `deploymentType`: string — Specifies whether the Timestream for InfluxDB is deployed as Single-AZ or with a MultiAZ Standby for High availability.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `influxDbInstanceRef`: [InfluxDBInstanceReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_timestream.InfluxDBInstanceReference.html) — A reference to a InfluxDBInstance resource.

- `logDeliveryConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnInfluxDBInstance.LogDeliveryConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_timestream.CfnInfluxDBInstance.LogDeliveryConfigurationProperty.html) — Configuration for sending InfluxDB engine logs to a specified S3 bucket.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `maintenanceSchedule`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnInfluxDBInstance.MaintenanceScheduleProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_timestream.CfnInfluxDBInstance.MaintenanceScheduleProperty.html) — The maintenance schedule for the InfluxDB instance.

- `name`: string — The name that uniquely identifies the DB instance when interacting with the Amazon Timestream for InfluxDB API and CLI commands.

- `networkType`: string — Network type of the InfluxDB Instance.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `organization`: string — The name of the initial organization for the initial admin user in InfluxDB.

- `password`: string — The password of the initial admin user created in InfluxDB.

- `port`: number — The port number on which InfluxDB accepts connections.

- `publiclyAccessible`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Configures the DB instance with a public IP to facilitate access.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A list of key-value pairs to associate with the DB instance.

- `username`: string — The username of the initial admin user created in InfluxDB.

- `vpcSecurityGroupIds`: string[] — A list of VPC security group IDs to associate with the DB instance.

- `vpcSubnetIds`: string[] — A list of VPC subnet IDs to associate with the DB instance.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForInfluxDBInstance(resource: IInfluxDBInstanceRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnInfluxDBInstance(x: any): boolean` (static) — Checks whether the given object is a CfnInfluxDBInstance.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
